%% This BibTeX bibliography file was created using BibDesk.
%% https://bibdesk.sourceforge.io/

%% Created for Roberta Calegari at 2018-11-26 12:07:53 +0100 


%% Saved with string encoding Unicode (UTF-8) 



@book{prologstandard-book1996,
	Author = {Deransart, Pierre and Dbali, AbdelAli Ed and Cervoni, Laurent},
	Booktitle = {{Prolog}: The Standard. Reference Manual},
	Date-Added = {2018-11-26 12:07:44 +0100},
	Date-Modified = {2018-11-26 12:07:44 +0100},
	Doi = {10.1007/978-3-642-61411-8},
	Isbn = {978-3-540-59304-1},
	Isbn-Online = {978-3-642-61411-8},
	Publisher = {Springer},
	Shorttitle = {{Prolog}: The Standard},
	Title = {{Prolog}: The Standard. Reference Manual},
	Url = {http://link.springer.com/10.1007/978-3-642-61411-8},
	Year = 1996,
	Bdsk-Url-1 = {http://dx.doi.org/10.1007/978-3-642-61411-8},
	Bdsk-Url-2 = {http://link.springer.com/10.1007/978-3-642-61411-8},
	Bdsk-Url-3 = {https://dx.doi.org/10.1007/978-3-642-61411-8}}

@incollection{naf-logicdbbook1978,
	Author = {Clark, Keith L.},
	Crossref = {logicdbbook1978},
	Date-Added = {2018-11-26 11:33:32 +0100},
	Date-Modified = {2018-11-26 11:33:32 +0100},
	Doi = {10.1007/978-1-4684-3384-5_11},
	Pages = {293--322},
	Title = {Negation as Failure},
	Url = {http://link.springer.com/10.1007/978-1-4684-3384-5_11},
	Bdsk-Url-1 = {http://dx.doi.org/10.1007/978-1-4684-3384-5_11},
	Bdsk-Url-2 = {http://link.springer.com/10.1007/978-1-4684-3384-5_11},
	Bdsk-Url-3 = {https://dx.doi.org/10.1007/978-1-4684-3384-5_11}}

@misc{MQTT-home,
	Abstract = {2013},
	Author = {{MQTT}},
	Date-Added = {2018-11-26 11:27:12 +0100},
	Date-Modified = {2018-11-26 11:27:12 +0100},
	Howpublished = {http://mqtt.org},
	Title = {{H}ome {P}age},
	Url = {http://mqtt.org},
	Urldate = 2017,
	Year = {2017},
	Bdsk-Url-1 = {http://www.aixia.it},
	Bdsk-Url-2 = {http://mqtt.org}}

@misc{JSON-home,
	Abstract = {2013},
	Author = {{JSON}},
	Date-Added = {2018-11-26 11:27:02 +0100},
	Date-Modified = {2018-11-26 11:27:02 +0100},
	Howpublished = {http://www.json.org},
	Title = {{H}ome {P}age},
	Urldate = 2017,
	Year = {2017},
	Bdsk-Url-1 = {http://www.aixia.it}}

@book{microservicespitfalls-book2016,
	Address = {Sebastopol, CA, USA},
	Author = {Richards, Mark},
	Date-Added = {2018-11-26 11:26:52 +0100},
	Date-Modified = {2018-11-26 11:26:52 +0100},
	Publisher = {O'Reilly},
	Title = {Microservices AntiPatterns and Pitfalls},
	Url = {http://www.oreilly.com/programming/free/microservices-antipatterns-and-pitfalls.csp},
	Year = 2016,
	Bdsk-Url-1 = {http://gen.lib.rus.ec/book/index.php?md5=3B504E6928D4D595DBC271EAA21355D1},
	Bdsk-Url-2 = {http://www.oreilly.com/programming/free/microservices-antipatterns-and-pitfalls.csp}}

@inproceedings{spatialtuples-idc2016,
	Address = {Berlin, Heidelberg},
	Author = {Ricci, Alessandro and Viroli, Mirko and Omicini, Andrea and Mariani, Stefano and Croatti, Angelo and Pianini, Danilo},
	Booktitle = {Intelligent Distributed Computing X. Proceedings of the 10th International Symposium on Intelligent Distributed Computing -- IDC 2016, Paris, France, October 10-12 2016},
	Date-Added = {2018-11-26 11:26:42 +0100},
	Date-Modified = {2018-11-26 11:26:42 +0100},
	Doi = {10.1007/978-3-319-48829-5_12},
	Editor = {Badica, Costin and El Fallah Seghrouchni, Amal and Beynier, Aur{\'e}lie and Camacho, David and Herpson, C{\'e}dric and Hindriks, Koen and Novais, Paulo},
	Isbn = {978-3-319-48828-8},
	Isbn-Online = {978-3-319-48829-5},
	Issn = {1860-949X},
	Keywords = {Multi-Agent Systems, Space-based Coordination, Spatial Computing, Augmented/Mixed Reality},
	Location = {Paris, France},
	Pages = {121--130},
	Publisher = {Springer},
	Scopusid = {2-s2.0-84992336025},
	Series = {Studies in Computational Intelligence},
	Title = {{S}patial {T}uples: Augmenting Physical Reality with Tuple Spaces},
	Url = {http://link.springer.com/10.1007/978-3-319-48829-5_12},
	Volume = 678,
	Year = 2017,
	Bdsk-Url-1 = {http://link.springer.com/10.1007/978-3-319-48829-5_12},
	Bdsk-Url-2 = {http://dx.doi.org/10.1007/978-3-319-48829-5_12},
	Bdsk-Url-3 = {https://dx.doi.org/10.1007/978-3-319-48829-5_12}}

@article{coordarch-eaai41,
	_Note = {{S}pecial Section on Agent-oriented Methods for Engineering Complex Distributed Systems},
	Author = {Mariani, Stefano and Omicini, Andrea},
	Date-Added = {2018-11-26 11:26:34 +0100},
	Date-Modified = {2018-11-26 11:26:34 +0100},
	Doi = {10.1016/j.engappai.2014.10.006},
	Editor = {Fortino, Giancarlo},
	Issn = {0952-1976},
	Journal = {Engineering Applications of Artificial Intelligence},
	Keywords = {MAS architecture; event-driven model; situatedness; coordination; TuCSoN},
	Month = may,
	Pages = {298--309},
	Publisher = {Elsevier},
	Scopusid = {2-s2.0-84924155453},
	Title = {Coordinating Activities and Change: An Event-Driven Architecture for Situated {MAS}},
	Url = {http://www.sciencedirect.com/science/article/pii/S0952197614002462},
	Volume = 41,
	Wosid = {000347789000009},
	Year = 2015,
	Bdsk-Url-1 = {http://www.sciencedirect.com/science/article/pii/S0952197614002462},
	Bdsk-Url-2 = {http://dx.doi.org/10.1016/j.engappai.2014.10.006},
	Bdsk-Url-3 = {https://dx.doi.org/10.1016/j.engappai.2014.10.006}}

@incollection{closedworld-logicdbbook1978,
	Author = {Reiter, Raymond},
	Crossref = {logicdbbook1978},
	Date-Added = {2018-11-26 11:26:25 +0100},
	Date-Modified = {2018-11-26 11:26:25 +0100},
	Doi = {10.1007/978-1-4684-3384-5_3},
	Pages = {55--76},
	Title = {On Closed World Data Bases},
	Url = {http://dx.doi.org/10.1007/978-1-4684-3384-5_3},
	Bdsk-Url-1 = {http://dx.doi.org/10.1007/978-1-4684-3384-5_3}}

@book{logicdbbook1978,
	Address = {Boston, MA, USA},
	Booktitle = {Logic and Data Bases},
	Date-Added = {2018-11-26 11:30:59 +0100},
	Date-Modified = {2018-11-26 11:30:59 +0100},
	Doi = {10.1007/978-1-4684-3384-5},
	Editor = {Gallaire, Herv{\'e} and Minker, Jack},
	Isbn = {978-1-4684-3384-5},
	Publisher = {Springer},
	Title = {Logic and Data Bases},
	Url = {http://link.springer.com/10.1007/978-1-4684-3384-5},
	Year = 1978,
	Bdsk-Url-1 = {http://dx.doi.org/10.1007/978-1-4684-3384-5_11},
	Bdsk-Url-2 = {http://link.springer.com/10.1007/978-1-4684-3384-5},
	Bdsk-Url-3 = {https://dx.doi.org/10.1007/978-1-4684-3384-5}}

@article{bugliesi-jlp19,
	Author = {Bugliesi, Michele and Lamma, Evelina and Mello, Paola},
	Date-Added = {2018-11-26 11:26:16 +0100},
	Date-Modified = {2018-11-26 11:26:16 +0100},
	Doi = {10.1016/0743-1066(94)90032-9},
	Editor = {Bruynooghe, Maurice and Debray, Saumya K. and Hermenegildo, Manuel V. and Maher, Michael J.},
	Issn = {0743-1066},
	Journal = {Journal of Logic Programming},
	Note = {Special Issue: Ten Years of Logic Programming},
	Pages = {443--502},
	Publisher = {Elsevier},
	Title = {Modularity in Logic Programming},
	Volume = {19--20},
	Year = 1994,
	Bdsk-Url-1 = {http://dx.doi.org/10.1016/0743-1066(94)90032-9},
	Bdsk-Url-2 = {https://dx.doi.org/10.1016/0743-1066(94)90032-9}}

@article{knowledge-representation-systems1992Beierle,
	Author = {Beierle, C. and Hedtst{\"u}ck, U. and Pletat, U. and Schmitt, P.H. and Siekmann, J.},
	Date-Added = {2018-11-14 17:21:25 +0100},
	Date-Modified = {2018-11-14 17:21:25 +0100},
	Doi = {10.1016/0004-3702(92)90055-3},
	Issn = {0004-3702},
	Journal = {Artificial Intelligence},
	Keywords = {Knowledge representation, inference systems, logic-based reasoning, sorted logic, taxonomic reasoning},
	Number = 2,
	Pages = {149--191},
	Title = {An order-sorted logic for knowledge representation systems},
	Url = {http://www.sciencedirect.com/science/article/pii/0004370292900553},
	Volume = 55,
	Year = 1992,
	Bdsk-Url-1 = {http://www.sciencedirect.com/science/article/pii/0004370292900553},
	Bdsk-Url-2 = {https://doi.org/10.1016/0004-3702(92)90055-3}}

@article{lpaas-bdcc2,
	Articleno = 23,
	Author = {Calegari, Roberta and Ciatto, Giovanni and Mariani, Stefano and Denti, Enrico and Omicini, Andrea},
	Date-Added = {2018-11-14 17:13:34 +0100},
	Date-Modified = {2018-11-14 17:13:34 +0100},
	Doi = {10.3390/bdcc2030023},
	Irisid = {11585/640012},
	Issn-Online = {2504-2289},
	Journal = {Big Data and Cognitive Computing},
	Keywords = {Logic Programming as a Service, IoT, symbolic reasoning},
	Number = 3,
	Numpages = 26,
	Publisher = {MDPI},
	Title = {{LPaaS} as Micro-intelligence: Enhancing {IoT} with Symbolic Reasoning},
	Url = {http://www.mdpi.com/2504-2289/2/3/23},
	Url-Pdf = {http://www.mdpi.com/2504-2289/2/3/23/pdf},
	Volume = 2,
	Year = 2018,
	Bdsk-Url-1 = {http://www.mdpi.com/2504-2289/2/3/23},
	Bdsk-Url-2 = {https://doi.org/10.3390/bdcc2030023}}

@misc{lpaas-home,
	Abstract = {2013},
	Author = {\lpaas{}},
	Date-Added = {2018-11-14 17:11:47 +0100},
	Date-Modified = {2018-11-16 09:58:26 +0100},
	Howpublished = {\url{http://lpaas.apice.unibo.it/}},
	Note = {(Accessed on 01 July 2018)},
	Organization = {\textsc{Alma Mater Studiorum}--Universit{\`a} di Bologna},
	Title = {Home Page},
	Url = {http://lpaas.apice.unibo.it/},
	Urldate = 2018,
	Year = 2018,
	Bdsk-Url-1 = {http://apice.unibo.it/xwiki/bin/view/LPaaS/}}

@book{continuousIntegration-duvall2007,
	Author = {Duvall, Paul M and Matyas, Steve and Glover, Andrew},
	Date-Added = {2018-11-14 17:11:27 +0100},
	Date-Modified = {2018-11-14 17:11:27 +0100},
	Publisher = {Addison-Wesley / Pearson Education},
	Title = {Continuous integration: improving software quality and reducing risk},
	Year = 2007}

@book{continuousDelivery-humble2010,
	Author = {Humble, Jez and Farley, David},
	Date-Added = {2018-11-14 17:11:27 +0100},
	Date-Modified = {2018-11-14 17:11:27 +0100},
	Isbn = {978--0--321--60191--9},
	Month = jul,
	Publisher = {Addison-Wesley / Pearson Education},
	Title = {Continuous delivery: reliable software releases through build, test, and deployment automation},
	Year = 2010}

@phdthesis{Fielding2000,
	Author = {Fielding, Roy Thomas},
	Date-Added = {2018-11-14 17:10:56 +0100},
	Date-Modified = {2018-11-14 17:10:56 +0100},
	Isbn = {0-599-87118-0},
	School = {University of California, Irvine},
	Title = {Architectural Styles and the Design of Network-based Software Architectures},
	Url = {https://www.ics.uci.edu/~fielding/pubs/dissertation/top.htm},
	Year = 2000,
	Bdsk-Url-1 = {https://www.ics.uci.edu/~fielding/pubs/dissertation/top.htm}}

@book{soabook-2005,
	Address = {Upper Saddle River, NJ, USA},
	Author = {Erl, Thomas},
	Date-Added = {2018-11-14 16:37:47 +0100},
	Date-Modified = {2018-11-14 16:37:47 +0100},
	Isbn = {0131428985},
	Publisher = {Prentice Hall / Pearson Education International},
	Title = {Service-Oriented Architecture: Concepts, Technology, and Design},
	Url = {https://www.pearsonhighered.com/program/Erl-Service-Oriented-Architecture-Concepts-Technology-and-Design/PGM137253.html},
	Year = 2005,
	Bdsk-Url-1 = {https://www.pearsonhighered.com/program/Erl-Service-Oriented-Architecture-Concepts-Technology-and-Design/PGM137253.html}}

@article{resolution-jacm12,
	Abstract = {Theorem-proving on the computer, using procedures based on the fund{\~{}}- mental theorem of Herbrand concerning the first-order predicate etdeulus, is examined with {\~{}} view towards improving the efticieney and widening the range of practical applicability of these procedures. A elose analysis of the process of substitution (of terms for variables), and the process of truth-functional analysis of the results of such substitutions, reveals that both processes can be combined into a single new process (called resolution), iterating which is vastty more ef[ieient than the older cyclic procedures consisting of substitution stages alternating with truth-functional analysis stages. The theory of the resolution process is presented in the form of a system of first{\textless}{\~{}}rder logic with .just one inference principle (the resolution principle). The completeness of the system is proved; the simplest proof-procedure based oil the system is then the direct im- plementation of the proof of completeness. Howew{\~{}}r, this procedure is quite inefficient, {\~{}}nd the paper concludes with a discussion of several principles (called search principles) which are applicable to the design of efficient proof-procedures employing resolution as the basle logical process.},
	Author = {Robinson, J. Alan},
	Date-Added = {2018-11-14 12:28:34 +0100},
	Date-Modified = {2018-11-14 12:28:34 +0100},
	Doi = {10.1145/321250.321253},
	Issn = {0004-5411},
	Journal = {Journal of the ACM},
	Month = jan,
	Number = 1,
	Pages = {23--41},
	Publisher = {ACM},
	Title = {A Machine-Oriented Logic Based on the Resolution Principle},
	Url = {http://dl.acm.org/citation.cfm?id=321253},
	Volume = 12,
	Year = 1965,
	Bdsk-Url-1 = {http://dl.acm.org/citation.cfm?id=321250.321253%20http://portal.acm.org/citation.cfm?doid=321250.321253%20http://delivery.acm.org/10.1145/330000/321253/p23-robinson.pdf},
	Bdsk-Url-2 = {http://dx.doi.org/10.1145/321250.321253},
	Bdsk-Url-3 = {http://dl.acm.org/citation.cfm?id=321253},
	Bdsk-Url-4 = {https://dx.doi.org/10.1145/321250.321253}}

@article{LP-to-agent-Kowalski1999,
	Abstract = {In this paper we present an extension of logic programming (LP) that is suitable not only for the ``rational'' component of a single agent but also for the ``reactive'' component and that can encompass multi‐agent systems. We modify an earlier abductive proof procedure and embed it within an agent cycle. The proof procedure incorporates abduction, definitions and integrity constraints within a dynamic environment, where changes can be observed as inputs. The definitions allow rational planning behaviour and the integrity constraints allow reactive, condition‐action type behaviour. The agent cycle provides a resource‐bounded mechanism that allows the agent's thinking to be interrupted for the agent to record and assimilate observations as input and execute actions as output, before resuming further thinking. We argue that these extensions of LP, accommodating multi‐theories embedded in a shared environment, provide the necessary multi‐agent functionality. We argue also that our work extends Shoham's Agent0 and the BDI architecture.},
	Author = {Kowalski, Robert and Sadri, Fariba},
	Date-Added = {2018-11-14 12:26:24 +0100},
	Date-Modified = {2018-11-14 12:28:48 +0100},
	Day = 01,
	Doi = {10.1023/A:1018934223383},
	Issn = {1573-7470},
	Journal = {Annals of Mathematics and Artificial Intelligence},
	Month = Nov,
	Number = 3,
	Pages = {391--419},
	Title = {From logic programming towards multi-agent systems},
	Url = {https://doi.org/10.1023/A:1018934223383},
	Volume = 25,
	Year = 1999,
	Bdsk-Url-1 = {https://doi.org/10.1023/A:1018934223383},
	Bdsk-Url-2 = {http://dx.doi.org/10.1023/A:1018934223383}}

@article{cognitiveArch-Sotnik2018,
	Abstract = {This article describes the open-source cognitive multi-agent knowledge-based SOSIEL (Self-Organizing Social & Inductive Evolutionary Learning) Platform, designed for building the social components of social-ecological decision support systems, consisting of agents empowered with a cognitive architecture. The platform can simulate the cross-generational progression of one or a large number of agents that can interact among themselves and/or with coupled natural and/or technical systems, learn from their and each other{\^a}s experience, create new practices, and make decisions about taking and then take (potentially collective) actions. The platform can also be used for conducting hypothetical experiments that are focused on studying the interactions among: (a) cross-generational population dynamics, (b) self-organizing multi-layered social network structures, (c) evolving place-based knowledge, (d) learning, (e) decision-making, (f) collective action and its potential, and (g) social and (when coupled) social-ecological outcomes. The article describes a simple model that was built with the SOSIEL Platform, which simulates the co-evolution of mental models among socially learning agents.},
	Author = {Sotnik, Garry},
	Date-Added = {2018-11-14 12:20:35 +0100},
	Date-Modified = {2018-11-14 12:26:19 +0100},
	Doi = {10.1016/j.bica.2018.09.001},
	Issn = {2212-683X},
	Journal = {Biologically Inspired Cognitive Architectures},
	Keywords = {Cognitive architecture, Collective action, Demographic processes, Knowledge-based, Multi-agent, Multi-layered social network structure},
	Note = {In Press},
	Title = {The SOSIEL Platform: Knowledge-based, cognitive, and multi-agent},
	Url = {http://www.sciencedirect.com/science/article/pii/S2212683X18301038},
	Year = 2018,
	Bdsk-Url-1 = {http://www.sciencedirect.com/science/article/pii/S2212683X18301038},
	Bdsk-Url-2 = {https://doi.org/10.1016/j.bica.2018.09.001}}

@inproceedings{spacetimelp-woa2018,
	Author = {Calegari, Roberta and Ciatto, Giovanni and Mariani, Stefano and Denti, Enrico and Omicini, Andrea},
	Booktitle = {WOA 2018 -- 19th Workshop ``From Objects to Agents''},
	Date-Added = {2018-11-14 11:54:56 +0100},
	Date-Modified = {2018-11-14 11:54:56 +0100},
	Editor = {Cossentino, Massimo and Sabatucci, Luca and Seidita, Valeria},
	Irisid = {11585/646038},
	Keywords = {LPaaS, situatedness, logic programming, SOA, space-time programming},
	Location = {Palermo, Italy},
	Month = {29--30~} # jun,
	Pages = {63--68},
	Publisher = {Sun SITE Central Europe, RWTH Aachen University},
	Scopus = {2-s2.0-85054314622},
	Series = {CEUR Workshop Proceedings},
	Subseries = {AI*IA Series},
	Title = {Logic Programming in Space-Time: The Case of Situatedness in {LPaaS}},
	Url-Pdf = {http://ceur-ws.org/Vol-2215/paper_11.pdf},
	Volume = 2215,
	Year = 2018}

@article{Clark1998,
	Author = {Clark, Andy and Chalmers, David J.},
	Date-Added = {2018-11-12 15:37:08 +0100},
	Date-Modified = {2018-11-12 15:37:48 +0100},
	Journal = {Analysis},
	Number = 1,
	Pages = {7--19},
	Publisher = {Oxford University Press},
	Title = {The Extended Mind},
	Volume = 58,
	Year = {1998}}

@inproceedings{montali2014,
	Address = {Paris, France},
	Author = {Montali, Marco and Calvanese, Diego and De Giacomo, Giuseppe},
	Booktitle = {13th International Conference on Autonomous Agents and Multiagent Systems (AAMAS 2014)},
	Date-Added = {2018-11-12 15:29:17 +0100},
	Date-Modified = {2018-11-12 15:32:11 +0100},
	Month = {05-09~} # may,
	Pages = {157--164},
	Publisher = {ACM},
	Title = {Verification of data-aware commitment-based multiagent system},
	Volume = 1,
	Year = 2014}

@article{gaia-zambo2003,
	Acmid = 958963,
	Address = {New York, NY, USA},
	Author = {Zambonelli, Franco and Jennings, Nicholas R. and Wooldridge, Michael},
	Date-Added = {2018-11-12 15:01:33 +0100},
	Date-Modified = {2018-11-12 15:04:19 +0100},
	Doi = {10.1145/958961.958963},
	Issn = {1049-331X},
	Issue_Date = {July 2003},
	Journal = {ACM Transactions on Software Engineering and Methodology (TOSEM)},
	Keywords = {Multiagent systems, agent-oriented software engineering, analysis and design methodologies, distributed systems, software architectures},
	Month = jul,
	Number = 3,
	Numpages = 54,
	Pages = {317--370},
	Publisher = {ACM},
	Title = {Developing Multiagent Systems: The Gaia Methodology},
	Url = {http://doi.acm.org/10.1145/958961.958963},
	Volume = 12,
	Year = 2003,
	Bdsk-Url-1 = {http://doi.acm.org/10.1145/958961.958963},
	Bdsk-Url-2 = {https://doi.org/10.1145/958961.958963}}

@inproceedings{situatedMAS-ferber-1996,
	Address = {Menlo Park, California, USA},
	Author = {Ferber, Jacques and Miiller, J. P.},
	Booktitle = {Second international conference on multi-agent systems (ICMAS 1996)},
	Date-Added = {2018-11-12 14:50:33 +0100},
	Date-Modified = {2018-11-16 09:57:23 +0100},
	Editor = {Tokoro, M},
	Pages = {72--79},
	Publisher = {AAAI Press},
	Title = {Influences and Reaction: a Model of Situated Multiagent Systems},
	Year = 1996}

@article{MAS-weyns2004,
	Acmid = 2370679,
	Address = {Amsterdam, The Netherlands},
	Author = {Weyns, Danny and Holvoet, Tom},
	Date-Added = {2018-11-12 14:44:15 +0100},
	Date-Modified = {2018-11-16 10:07:13 +0100},
	Issn = {0169-2968},
	Issue_Date = {April 2004},
	Journal = {Fundamenta Informaticae},
	Month = apr,
	Number = {2-3},
	Numpages = 34,
	Pages = {125--158},
	Publisher = {IOS Press},
	Title = {A Formal Model for Situated Multi-Agent Systems},
	Url = {http://dl.acm.org/citation.cfm?id=2370676.2370679},
	Volume = 63,
	Year = 2004,
	Bdsk-Url-1 = {http://dl.acm.org/citation.cfm?id=2370676.2370679}}

@book{Suchman:1987,
	Address = {New York, NY, USA},
	Author = {Suchman, Lucy A.},
	Date-Added = {2018-11-12 14:34:03 +0100},
	Date-Modified = {2018-11-12 14:34:12 +0100},
	Isbn = {0-521-33137-4},
	Publisher = {Cambridge University Press},
	Title = {Plans and Situated Actions: The Problem of Human-machine Communication},
	Year = 1987}

@article{artifacts-jaamas17,
	Author = {Omicini, Andrea and Ricci, Alessandro and Viroli, Mirko},
	Date-Added = {2018-11-12 12:51:11 +0100},
	Date-Modified = {2018-11-12 12:51:11 +0100},
	Doi = {10.1007/s10458-008-9053-x},
	Editor = {Omicini, Andrea and McBurney, Peter},
	Issn = {1387-2532},
	Issn-Online = {1573-7454},
	Journal = {Autonomous Agents and Multi-Agent Systems},
	Month = dec,
	Note = {Special Issue on Foundations, Advanced Topics and Industrial Perspectives of Multi-Agent Systems},
	Number = 3,
	Pages = {432--456},
	Publisher = {Springer},
	Scopusid = {2-s2.0-52949149709},
	Title = {Artifacts in the {A\&A} Meta-Model for Multi-Agent Systems},
	Url = {http://link.springer.com/10.1007/s10458-008-9053-x},
	Volume = 17,
	Wosid = {000259411800004},
	Year = 2008,
	Bdsk-Url-1 = {http://link.springer.com/10.1007/s10458-008-9053-x},
	Bdsk-Url-2 = {https://doi.org/10.1007/s10458-008-9053-x}}

@article{env-jaamas14,
	Author = {Weyns, Danny and Omicini, Andrea and Odell, James J.},
	Date-Added = {2018-11-12 12:48:57 +0100},
	Date-Modified = {2018-11-12 12:48:57 +0100},
	Doi = {10.1007/s10458-006-0012-0},
	Editor = {Weyns, Danny and Parunak, H. Van Dyke},
	Issn = {1387-2532},
	Issn-Online = {1573-7454},
	Journal = {Autonomous Agents and Multi-Agent Systems},
	Keywords = {Environment in multiagent systems; Definition, responsibilities, reference model of the environment},
	Month = feb,
	Note = {Special Issue on Environments for Multi-agent Systems},
	Number = 1,
	Pages = {5--30},
	Publisher = {Springer Netherlands},
	Scopusid = {2-s2.0-35148899434},
	Title = {Environment as a First Class Abstraction in Multi-Agent Systems},
	Url = {http://link.springer.com/10.1007/s10458-006-0012-0},
	Volume = 14,
	Wosid = {000242155200002},
	Year = 2007,
	Bdsk-Url-1 = {http://link.springer.com/10.1007/s10458-006-0012-0},
	Bdsk-Url-2 = {https://doi.org/10.1007/s10458-006-0012-0}}

@incollection{artifacts-selmasIV,
	Author = {Omicini, Andrea and Ricci, Alessandro and Viroli, Mirko},
	Booktitle = {Software Engineering for Multi-Agent Systems IV: Research Issues and Practical Applications},
	Date-Added = {2018-11-12 12:43:08 +0100},
	Date-Modified = {2018-11-12 12:43:08 +0100},
	Doi = {10.1007/11738817_5},
	Editor = {Garcia, Alessandro F. and Choren, Ricardo and Lucena, Carlos and Giorgini, Paolo and Holvoet, Tom and Romanovsky, Alexander},
	Isbn = {978-3-540-33580-1},
	Isbn-10 = {3-540-33580-3},
	Isbn-Online = {978-3-540-33583-2},
	Issn = {0302-9743},
	Month = apr,
	Note = {Invited Paper},
	Pages = {71--90},
	Publisher = {Springer Berlin Heidelberg},
	Scopusid = {2-s2.0-34250005140},
	Series = {Lecture Notes in Computer Science},
	Title = {Coordination Artifacts as First-class Abstractions for {MAS} Engineering: State of the Research},
	Url = {http://link.springer.com/10.1007/11738817_5},
	Volume = 3914,
	Wosid = {000238283600005},
	Year = 2006,
	Bdsk-Url-1 = {http://link.springer.com/10.1007/11738817_5},
	Bdsk-Url-2 = {https://doi.org/10.1007/11738817_5}}

@inproceedings{artifacts-aamas07,
	Acmid = {1329308},
	Address = {Honolulu, Hawai'i, USA},
	Articleno = {150},
	Author = {Ricci, Alessandro and Viroli, Mirko and Omicini, Andrea},
	Booktitle = {6th International Joint Conference ``Autonomous Agents \& Multi-Agent Systems'' (AAMAS 2007)},
	Date-Added = {2018-11-12 12:42:16 +0100},
	Date-Modified = {2018-11-16 09:59:52 +0100},
	Doi = {10.1145/1329125.1329308},
	Editor = {Durfee, Edmund and Yokoo, Makoto and Huhns, Michael and Shehory, Onn},
	Isbn = {978-81-904262-7-5},
	Month = {14--18~} # may,
	Numpages = 3,
	Pages = {601--603},
	Publisher = {IFAAMAS},
	Scopusid = {2-s2.0-60349099652},
	Title = {``{G}ive Agents their Artifacts'': The {A\&A} Approach for Engineering Working Environments in {MAS}},
	Url = {http://dl.acm.org/citation.cfm?id=1329308},
	Year = 2007,
	Bdsk-Url-1 = {http://dl.acm.org/citation.cfm?id=1329308},
	Bdsk-Url-2 = {https://doi.org/10.1145/1329125.1329308}}

@incollection{environment4MAS-zambonelli2005,
	Address = {Berlin, Heidelberg},
	Author = {Mamei, Marco and Zambonelli, Franco},
	Booktitle = {Environments for Multi-Agent Systems II (E4MAS 2005)},
	Date-Added = {2018-11-12 12:19:56 +0100},
	Date-Modified = {2018-11-12 12:28:16 +0100},
	Doi = {10.1007/11678809_11},
	Editor = {Weyns, Danny and Van Dyke Parunak, H. and Michel, F},
	Month = Jul,
	Pages = {187--204},
	Publisher = {Springer},
	Series = {Lecture Notes in Computer Science},
	Title = {Augmenting the Physical Environment Through Embedded Wireless Technologies},
	Volume = 3830,
	Year = 2005,
	Bdsk-Url-1 = {https://doi.org/10.1007/11678809_11}}

@inproceedings{awareMAS-montali2016,
	Abstract = {We recall the key abstractions and models on which the major approaches to software specification rely, using Meyer's forces of computation as dimensions of comparison. Based on the identified strengths and lacks, we introduce data-awareness and of norm-awareness as recommended properties, explaining the advantages they bring about. We show that multiagent systems are a good candidate for the development of a data- and norm-aware programming, tracing directions for the realization of multiagent systems that are data and norm-aware. Finally, we report and comment some proposals from the multiagent systems literature that, though developed independently and not inserted in an organic framework, already face specific aspects that are relevant to bring about norm and data-awareness.},
	Author = {Baldoni, Matteo and Baroglio, Cristina and Calvanese, Diego and Micalizio, Roberto and Montali, Marco},
	Booktitle = {Engineering Multi-Agent Systems},
	Date-Added = {2018-11-12 11:56:17 +0100},
	Date-Modified = {2018-11-12 12:19:52 +0100},
	Doi = {10.1007/978-3-319-50983-9_2},
	Editor = {Baldoni, Matteo and M{\"u}ller, J{\"o}rg P. and Nunes, Ingrid and Zalila-Wenkstern, Rym},
	Isbn = {978-3-319-50983-9},
	Pages = {22--38},
	Publisher = {Springer International Publishing},
	Series = {Lecture Notes in Computer Science (LNCS)},
	Title = {Towards Data- and Norm-Aware Multiagent Systems},
	Url = {http://link.springer.com/10.1007/978-3-319-50983-9_2},
	Volume = 10093,
	Year = 2016,
	Bdsk-Url-1 = {http://link.springer.com/10.1007/978-3-319-50983-9_2},
	Bdsk-Url-2 = {https://doi.org/10.1007/978-3-319-50983-9_2}}

@inbook{cognitiveScience-clark-2017,
	Abstract = {Summary Biological brains are first and foremost the control systems for biological bodies. Biological bodies move and act in rich real-world surroundings. These apparently mundane facts are amongst the main driving forces behind a growing movement within cognitive science {\^a} a movement that seeks to reorient the scientific study of mind so as to better accommodate the roles of embodiment and environmental embedding.},
	Author = {Clark, Andy},
	Booktitle = {A Companion to Cognitive Science},
	Chapter = 39,
	Date-Added = {2018-11-12 11:13:12 +0100},
	Date-Modified = {2018-11-12 11:17:01 +0100},
	Doi = {10.1002/9781405164535.ch39},
	Eprint = {https://onlinelibrary.wiley.com/doi/pdf/10.1002/9781405164535.ch39},
	Isbn = {9781405164535},
	Pages = {506--517},
	Publisher = {John Wiley \& Sons, Ltd},
	Title = {Embodied, Situated, and Distributed Cognition},
	Url = {https://onlinelibrary.wiley.com/doi/abs/10.1002/9781405164535.ch39},
	Year = 2017,
	Bdsk-Url-1 = {https://onlinelibrary.wiley.com/doi/abs/10.1002/9781405164535.ch39},
	Bdsk-Url-2 = {https://doi.org/10.1002/9781405164535.ch39}}

@article{distributedcognition-hollan-2000,
	Author = {Hollan, James and Hutchins, Edwin and Kirsh, David},
	Date-Added = {2018-11-12 10:52:55 +0100},
	Date-Modified = {2018-11-12 11:15:51 +0100},
	Journal = {ACM Transactions on Computer-Human Interaction (TOCHI)},
	Pages = {174--196},
	Publisher = {ACM},
	Title = {Distributed Cognition: Toward a New Foundation for Human-Computer Interaction Research},
	Volume = 7,
	Year = 2000}

@inproceedings{microintelligencelp-mmas2018,
	Abstract = {Pervasiveness of ICT resources along with the promise of ubiquitous intelligence is pushing hard both our demand and our fears of AI: demand mandates for the ability to inject (micro) intelligence ubiquitously, fears compel the behaviour of intelligent systems to be observable, explainable, and accountable. Whereas the first wave of the new ``AI Era'' was mostly heralded by non-symbolic approaches, features like explainability are better provided by symbolic techniques. In this paper we focus on logic-based approaches, and discuss their potential in pervasive scenarios like the IoT and open (M)MAS along with our latest results in the field.},
	Address = {Stockholm, Sweden},
	Author = {Omicini, Andrea and Calegari, Roberta},
	Booktitle = {International Workshop on Massively Multi-Agent Systems (MMAS) 2018},
	Date-Added = {2018-11-12 10:19:58 +0100},
	Date-Modified = {2018-11-16 10:11:57 +0100},
	Keywords = {pervasive system, MMAS, micro-intelligence, logic-based, LPaaS.},
	Month = Jul,
	Title = {Injecting (Micro)Intelligence in the IoT: Logic-based Approaches for (M)MAS},
	Year = 2018}

@incollection{wfms-coord06,
	Author = {Omicini, Andrea and Ricci, Alessandro and Zaghini, Nicola},
	Booktitle = {Coordination Models and Languages},
	Date-Added = {2018-07-06 18:22:45 +0000},
	Date-Modified = {2018-07-06 18:27:25 +0000},
	Doi = {10.1007/11767954\_15},
	Editor = {Ciancarini, Paolo and Wiklicky, Herbert},
	Isbn = {978-3-540-34694-4},
	Isbn-10 = {3-540-34694-5},
	Isbn-Online = {978-3-540-34695-1},
	Issn = {0302-9743},
	Month = jun,
	Note = {8th International Conference (COORDINATION 2006), Bologna, Italy, 14--16~} # jun # {~2006. Proceedings},
	Pages = {228--246},
	Publisher = {Springer},
	Series = {LNCS},
	Title = {Distributed Workflow upon Linkable Coordination Artifacts},
	Url = {http://link.springer.com/chapter/10.1007/11767954\_15},
	Volume = 4038,
	Wosid = {000239479100015},
	Year = 2006,
	Bdsk-Url-1 = {http://link.springer.com/chapter/10.1007/11767954_15},
	Bdsk-Url-2 = {https://doi.org/10.1007/11767954_15},
	Bdsk-Url-3 = {http://link.springer.com/chapter/10.1007/11767954%5C_15},
	Bdsk-Url-4 = {https://doi.org/10.1007/11767954%5C_15}}

@inproceedings{aclt-aiia95,
	Acmid = {761273},
	Author = {Omicini, Andrea and Denti, Enrico and Natali, Antonio},
	Booktitle = {Topics in Artificial Intelligence},
	Date-Added = {2018-07-06 18:14:54 +0000},
	Date-Modified = {2018-07-06 18:25:44 +0000},
	Doi = {10.1007/3-540-60437-5\_43},
	Editor = {Gori, Marco and Soda, Giovanni},
	Isbn = {978-3-540-60437-2},
	Isbn-10 = {978-3-540-47468-5},
	Isbn-Online = {3-540-60437-5},
	Issn = {0302-9743},
	Note = {4th Congress of the Italian Association for Artificial Intelligence (AI*IA'95), Florence, Italy, 11--13~} # oct # {~1995, Proceedings},
	Pages = {439--450},
	Publisher = {Springer-Verlag},
	Scopusid = {2-s2.0-84957673013},
	Series = {LNAI},
	Title = {Agent Coordination and Control through Logic Theories},
	Url = {http://link.springer.com/10.1007/3-540-60437-5\_43},
	Volume = 992,
	Wosid = {A1995BF24X00043},
	Year = 1995,
	Bdsk-Url-1 = {http://link.springer.com/10.1007/3-540-60437-5_43},
	Bdsk-Url-2 = {https://doi.org/10.1007/3-540-60437-5_43},
	Bdsk-Url-3 = {http://link.springer.com/10.1007/3-540-60437-5%5C_43},
	Bdsk-Url-4 = {https://doi.org/10.1007/3-540-60437-5%5C_43}}

@inproceedings{respect-sac98,
	Address = {Atlanta, GA, USA},
	Author = {Denti, Enrico and Natali, Antonio and Omicini, Andrea},
	Booktitle = {1998 ACM Symposium on Applied Computing (SAC'98)},
	Date-Added = {2018-07-06 18:13:43 +0000},
	Date-Modified = {2018-07-06 18:13:43 +0000},
	Doi = {10.1145/330560.330665},
	Isbn = {0-89791-969-6},
	Month = {27~} # feb # {--1~} # mar,
	Note = {Special Track on Coordination Models, Languages and Applications},
	Pages = {169--177},
	Publisher = {ACM},
	Scopusid = {2-s2.0-85002410745},
	Title = {On the Expressive Power of a Language for Programming Coordination Media},
	Url = {http://dl.acm.org/citation.cfm?id=330665},
	Url-Pdf = {http://delivery.acm.org/10.1145/340000/330665/p169-denti.pdf},
	Year = 1998,
	Bdsk-Url-1 = {http://dl.acm.org/citation.cfm?id=330665},
	Bdsk-Url-2 = {https://doi.org/10.1145/330560.330665},
	Bdsk-Url-3 = {http://delivery.acm.org/10.1145/340000/330665/p169-denti.pdf}}

@article{coord-fundinfo73,
	Author = {Viroli, Mirko and Omicini, Andrea},
	Date-Added = {2018-07-06 18:07:10 +0000},
	Date-Modified = {2018-07-06 18:07:10 +0000},
	Editor = {Brogi, Antonio and Jacquet, Jean-Marie and Kok, Joost},
	Issn = {0169-2968},
	Issn-Online = {1875-8681},
	Journal = {Fundamenta Informaticae},
	Note = {Special Issue: Best papers of FOCLASA 2002},
	Number = 4,
	Pages = {507--534},
	Publisher = {IOS Press},
	Scopusid = {2-s2.0-33746222313},
	Title = {Coordination as a Service},
	Url = {http://content.iospress.com/articles/fundamenta-informaticae/fi73-4-04},
	Volume = 73,
	Year = 2006,
	Bdsk-Url-1 = {http://content.iospress.com/articles/fundamenta-informaticae/fi73-4-04}}

@article{respect-entcs175,
	Author = {Omicini, Andrea},
	Date-Added = {2018-07-06 17:05:27 +0000},
	Date-Modified = {2018-07-06 17:05:27 +0000},
	Doi = {10.1016/j.entcs.2007.03.006},
	Editor = {Canal, Carlos and Viroli, Mirko},
	Elsevier-Ref = {ENTCS1735},
	Issn = {1571-0661},
	Journal = {Electronic Notes in Theoretical Computer Science},
	Keywords = {Tuple-based Coordination, Artifacts for MAS, A\&A, Tuple Centres, ReSpecT},
	Month = jun,
	Note = {5th International Workshop on Foundations of Coordination Languages and Software Architectures (FOCLASA'06), CONCUR'06, Bonn, Germany, 31~} # aug # {~2006. Post-proceedings},
	Number = 2,
	Pages = {97--117},
	Publisher = {Elsevier Science B.V.},
	Title = {Formal {{\sf ReSpecT}} in the {A\&A} Perspective},
	Url = {http://www.sciencedirect.com/science/article/pii/S1571066107003519},
	Volume = 175,
	Year = 2007,
	Bdsk-Url-1 = {http://www.sciencedirect.com/science/article/pii/S1571066107003519},
	Bdsk-Url-2 = {http://dx.doi.org/10.1016/j.entcs.2007.03.006}}

@article{linda-toplas7,
	Author = {Gelernter, David},
	Date-Added = {2018-07-06 16:57:05 +0000},
	Date-Modified = {2018-07-06 16:57:05 +0000},
	Doi = {10.1145/2363.2433},
	Doi-Acm = {http://doi.acm.org/10.1145/2363.2433},
	Issn = {0164-0925},
	Journal = {ACM Transactions on Programming Languages and Systems},
	Month = jan,
	Number = 1,
	Pages = {80--112},
	Publisher = {ACM Press},
	Title = {Generative Communication in {L}inda},
	Url = {http://portal.acm.org/citation.cfm?id=2433},
	Volume = 7,
	Year = 1985,
	Bdsk-Url-1 = {http://portal.acm.org/citation.cfm?id=2433},
	Bdsk-Url-2 = {http://dx.doi.org/10.1145/2363.2433},
	Bdsk-Url-3 = {http://doi.acm.org/10.1145/2363.2433}}

@article{ciancarini-acmcs28,
	Acmid = {234732},
	Author = {Ciancarini, Paolo},
	Date-Added = {2018-07-06 16:47:07 +0000},
	Date-Modified = {2018-07-06 16:47:07 +0000},
	Doi = {10.1145/234528.234732},
	Issn = {0360-0300},
	Journal = {ACM Computing Surveys},
	Month = jun,
	Number = 2,
	Pages = {300--302},
	Publisher = {ACM Press},
	Title = {Coordination Models and Languages as Software Integrators},
	Url = {http://portal.acm.org/citation.cfm?id=234732},
	Volume = 28,
	Year = 1996,
	Bdsk-Url-1 = {http://portal.acm.org/citation.cfm?id=234732},
	Bdsk-Url-2 = {https://doi.org/10.1145/234528.234732}}

@incollection{coord-atalVI,
	Author = {Ciancarini, Paolo and Omicini, Andrea and Zambonelli, Franco},
	Booktitle = {Intelligent Agents VI. Agent Theories, Architectures, and Languages},
	Date-Added = {2018-07-06 16:43:24 +0000},
	Date-Modified = {2018-07-06 17:08:00 +0000},
	Doi = {10.1007/10719619\_19},
	Editor = {Jennings, Nicholas R. and Lesp\'{e}rance, Yves},
	Isbn = {978-3-540-67200-5},
	Isbn-10 = {3-540-67200-1},
	Issn = {0302-9743},
	Issn-Online = {1611-3349},
	Note = {6th International Workshop (ATAL'99), Orlando, FL, USA, 15--17~} # jul # {~1999. Proceedings},
	Pages = {250--259},
	Publisher = {Springer},
	Scopusid = {2-s2.0-84942942991},
	Series = {LNAI},
	Title = {Multiagent System Engineering: The Coordination Viewpoint},
	Url = {http://link.springer.com/10.1007/10719619\_19},
	Volume = 1757,
	Year = 2000,
	Bdsk-Url-1 = {http://link.springer.com/10.1007/10719619_19},
	Bdsk-Url-2 = {https://doi.org/10.1007/10719619_19},
	Bdsk-Url-3 = {http://link.springer.com/10.1007/10719619%5C_19},
	Bdsk-Url-4 = {https://doi.org/10.1007/10719619%5C_19}}

@incollection{respect-coord97,
	Acmid = {713152},
	Author = {Denti, Enrico and Natali, Antonio and Omicini, Andrea},
	Booktitle = {Coordination Languages and Models},
	Date-Added = {2018-07-06 16:38:50 +0000},
	Date-Modified = {2018-07-06 17:06:09 +0000},
	Doi = {10.1007/3-540-63383-9\_86},
	Editor = {Garlan, David and Le M{\'e}tayer, Daniel},
	Isbn = {978-3-540-63383-9},
	Isbn-10 = {3-540-63383-9},
	Isbn-Online = {978-3-540-69527-1},
	Issn = {0302-9743},
	Keywords = {Coordination Models, Programmable Coordination Media, Reactions, Tuple Spaces, Multi-Agent Systems},
	Note = {2nd International Conference (COORDINATION'97), Berlin, Germany, 1--3~} # sep # {~1997. Proceedings},
	Pages = {274--288},
	Publisher = {Springer-Verlag},
	Scopusid = {2-s2.0-84957066558},
	Series = {LNCS},
	Title = {Programmable Coordination Media},
	Url = {http://link.springer.com/10.1007/3-540-63383-9\_86},
	Volume = 1282,
	Year = 1997,
	Bdsk-Url-1 = {http://link.springer.com/10.1007/3-540-63383-9_86},
	Bdsk-Url-2 = {https://doi.org/10.1007/3-540-63383-9_86},
	Bdsk-Url-3 = {http://link.springer.com/10.1007/3-540-63383-9%5C_86},
	Bdsk-Url-4 = {https://doi.org/10.1007/3-540-63383-9%5C_86}}

@article{tucson-jaamas2,
	Author = {Omicini, Andrea and Zambonelli, Franco},
	Date-Added = {2018-07-05 16:11:36 +0000},
	Date-Modified = {2018-07-05 16:11:36 +0000},
	Doi = {10.1023/A:1010060322135},
	Editor = {Tolksdorf, Robert and Ciancarini, Paolo},
	Issn = {1387-2532},
	Issn-Online = {1573-7454},
	Journal = {Autonomous Agents and Multi-Agent Systems},
	Keywords = {coordination, Internet applications, mobile agents, programmable tuple spaces},
	Month = sep,
	Note = {Special Issue: Coordination Mechanisms for Web Agents},
	Number = 3,
	Pages = {251--269},
	Publisher = {Springer Netherlands},
	Scopusid = {2-s2.0-0041593714},
	Title = {Coordination for {I}nternet Application Development},
	Url = {http://link.springer.com/10.1023/A:1010060322135},
	Volume = 2,
	Year = 1999,
	Bdsk-Url-1 = {http://link.springer.com/10.1023/A:1010060322135},
	Bdsk-Url-2 = {https://doi.org/10.1023/A:1010060322135}}

@article{respect-scico41,
	Author = {Omicini, Andrea and Denti, Enrico},
	Date-Added = {2018-07-05 13:06:23 +0000},
	Date-Modified = {2018-07-05 13:06:23 +0000},
	Doi = {10.1016/S0167-6423(01)00011-9},
	Issn = {0167-6423},
	Journal = {Science of Computer Programming},
	Month = nov,
	Number = 3,
	Pages = {277--294},
	Publisher = {Elsevier Science B. V.},
	Title = {From Tuple Spaces to Tuple Centres},
	Volume = 41,
	Year = 2001,
	Bdsk-Url-1 = {http://dx.doi.org/10.1016/S0167-6423(01)00011-9}}

@article{lpaas-tplp18,
	Author = {Calegari, Roberta and Denti, Enrico and Mariani, Stefano and Omicini, Andrea},
	Date-Added = {2018-07-05 12:53:26 +0000},
	Date-Modified = {2018-07-05 12:53:26 +0000},
	Doi = {10.1017/S1471068418000364},
	Editor = {Pontelli, Enrico and Fioretto, Ferdinando},
	Journal = {Theory and Practice of Logic Programming},
	Keywords = {logic programming, distributed systems, service-oriented architectures, pervasive systems, intelligent systems, LPaaS, situatedness},
	Note = {Special Issue ``Past and Present (and Future) of Parallel and Distributed Computation in (Constraint) Logic Programming''},
	Number = {3-4},
	Pages = {1--28},
	Publisher = {Cambridge University Press},
	Title = {Logic Programming as a Service},
	Volume = 18,
	Year = 2018,
	Bdsk-Url-1 = {https://doi.org/10.1017/S1471068418000364}}

@inproceedings{logicsmartcontracts-ruleml2016,
	Abstract = {While procedural languages are commonly used to program smart contracts in blockchain systems, logic-based languages may be interesting alternatives. In this paper, we inspect what are the possible legal and technical (dis)advantages of logic-based smart contracts in light of common activities featuring ordinary contracts, then we provide insights on how to use such logic-based smart contracts in combination with blockchain systems. These insights lead us to emphasize a fundamental challenge - algorithms for logic approaches have to be efficient, but they also need to be literally cheap as measured within the environment where they are deployed and according to its economic rules. We illustrate this with different algorithms from defeasible logic-based frameworks.},
	Author = {Idelberger, Florian and Governatori, Guido and Riveret, R{\'e}gis and Sartor, Giovanni},
	Booktitle = {Rule Technologies. Research, Tools, and Applications},
	Date-Added = {2018-07-05 12:37:28 +0000},
	Date-Modified = {2018-07-05 12:38:03 +0000},
	Doi = {10.1007/978-3-319-42019-6\_11},
	Editor = {Alferes, Jose Julio and Bertossi, Leopoldo and Governatori, Guido and Fodor, Paul and Roman, Dumitru},
	Isbn = {978-3-319-42019-6},
	Pages = {167--183},
	Publisher = {Springer},
	Series = {Lecture Notes in Computer Science},
	Title = {Evaluation of Logic-Based Smart Contracts for Blockchain Systems},
	Url = {http://link.springer.com/10.1007/978-3-319-42019-6\_11},
	Volume = 9718,
	Year = 2016,
	Bdsk-Url-1 = {http://link.springer.com/10.1007/978-3-319-42019-6_11},
	Bdsk-Url-2 = {https://doi.org/10.1007/978-3-319-42019-6_11},
	Bdsk-Url-3 = {http://link.springer.com/10.1007/978-3-319-42019-6%5C_11},
	Bdsk-Url-4 = {https://doi.org/10.1007/978-3-319-42019-6%5C_11}}

@incollection{mas-daltI,
	Author = {Omicini, Andrea and Zambonelli, Franco},
	Booktitle = {Declarative Agent Languages and Technologies},
	Date-Added = {2018-07-05 12:34:12 +0000},
	Date-Modified = {2018-07-05 12:35:12 +0000},
	Doi = {10.1007/978-3-540-25932-9\_1},
	Editor = {Leite, Jo{\~a}o Alexandre and Omicini, Andrea and Sterling, Leon and Torroni, Paolo},
	Isbn = {978-3-540-22124-1},
	Isbn-10 = {3-540-22124-7},
	Isbn-Online = {978-3-540-25932-9},
	Issn = {0302-9743},
	Issn-Online = {1611-3349},
	Month = may,
	Note = {1st International Workshop (DALT 2003), Melbourne, Australia, 15~} # jul # {~2003. Revised Selected and Invited Papers},
	Pages = {1--17},
	Publisher = {Springer Berlin Heidelberg},
	Scopusid = {2-s2.0-23244434648},
	Series = {Lecture Notes in Computer Science},
	Subseries = {Lecture Notes in Artificial Intelligence},
	Title = {{MAS} as Complex Systems: A View on the Role of Declarative Approaches},
	Url = {http://link.springer.com/10.1007/978-3-540-25932-9\_1},
	Volume = 2990,
	Wosid = {000222257200001},
	Year = 2004,
	Bdsk-Url-1 = {http://link.springer.com/10.1007/978-3-540-25932-9_1},
	Bdsk-Url-2 = {https://doi.org/10.1007/978-3-540-25932-9_1},
	Bdsk-Url-3 = {http://link.springer.com/10.1007/978-3-540-25932-9%5C_1},
	Bdsk-Url-4 = {https://doi.org/10.1007/978-3-540-25932-9%5C_1}}

@article{alphago-nature529,
	Author = {Silver, David and Huang, Aja and Maddison, Chris J. and Guez, Arthur and Sifre, Laurent and van den Driessche, George and Schrittwieser, Julian and Antonoglou, Ioannis and Panneershelvam, Veda and Lanctot, Marc and Dieleman, Sander and Grewe, Dominik and Nham, John and Kalchbrenner, Nal and Sutskever, Ilya and Lillicrap, Timothy and Leach, Madeleine and Kavukcuoglu, Koray and Graepel, Thore and Hassabis, Demis},
	Date-Added = {2018-07-05 12:30:54 +0000},
	Date-Modified = {2018-07-05 12:30:54 +0000},
	Doi = {10.1038/nature16961},
	Journal = {Nature},
	Month = jan,
	Pages = {484--489},
	Publisher = {Nature Publishing Group},
	Title = {Mastering the game of {G}o with deep neural networks and tree search},
	Url = {http://www.nature.com/articles/nature16961},
	Volume = 529,
	Year = 2016,
	Bdsk-Url-1 = {http://dx.doi.org/10.1038/nature16961},
	Bdsk-Url-2 = {http://www.nature.com/articles/nature16961}}

@article{massurvey-ia7,
	Author = {Omicini, Andrea and Mariani, Stefano},
	Date-Added = {2018-07-05 11:29:02 +0000},
	Date-Modified = {2018-07-05 11:29:02 +0000},
	Doi = {10.3233/IA-130056},
	Editor = {Baldoni, Matteo and Mello, Paola and Riguzzi, Fabrizio},
	Issn = {1724-8035},
	Issn-Online = {2211-0097},
	Journal = {Intelligenza Artificiale},
	Keywords = {Agents, Intelligent agents, Multiagent systems, Complex systems, Agent-Oriented Software Engineering, Pervasive Computing, Self-Organisation, Simulation, AI*IA},
	Month = nov,
	Note = {{S}pecial Issue Celebrating 25 years of the Italian Association for Artificial Intelligence},
	Number = 2,
	Pages = {153---164},
	Publisher = {IOS Press},
	Title = {Agents \& Multiagent Systems: En Route Towards Complex Intelligent Systems},
	Url = {http://content.iospress.com/articles/intelligenza-artificiale/ia056},
	Volume = 7,
	Year = 2013,
	Bdsk-Url-1 = {http://content.iospress.com/articles/intelligenza-artificiale/ia056},
	Bdsk-Url-2 = {http://dx.doi.org/10.3233/IA-130056}}

@article{aose-jaamas9,
	Author = {Zambonelli, Franco and Omicini, Andrea},
	Date-Added = {2018-07-05 11:27:50 +0000},
	Date-Modified = {2018-07-05 11:27:50 +0000},
	Doi = {10.1023/B:AGNT.0000038028.66672.1e},
	Editor = {Luck, Michael},
	Issn = {1387-2532},
	Journal = {Autonomous Agents and Multi-Agent Systems},
	Month = nov,
	Note = {Special Issue: Challenges for Agent-Based Computing},
	Number = 3,
	Open-Url = {http://springerlink.metapress.com/openurl.asp?genre=article&issn=1387-2532&volume=9&issue=3&spage=253},
	Pages = {253--283},
	Publisher = {Springer Netherlands},
	Title = {Challenges and Research Directions in Agent-Oriented Software Engineering},
	Url = {http://www.springerlink.com/content/jmm61l312478610j/},
	Volume = 9,
	Year = 2004,
	Bdsk-Url-1 = {http://www.springerlink.com/content/jmm61l312478610j/},
	Bdsk-Url-2 = {http://dx.doi.org/10.1023/B:AGNT.0000038028.66672.1e},
	Bdsk-Url-3 = {http://springerlink.metapress.com/openurl.asp?genre=article&issn=1387-2532&volume=9&issue=3&spage=253}}

@article{iotse-ieeesw34,
	Author = {Zambonelli, Franco},
	Date-Added = {2018-07-05 11:23:53 +0000},
	Date-Modified = {2018-07-05 11:24:29 +0000},
	Doi = {10.1109/MS.2017.3},
	Issn = {0740-7459},
	Journal = {IEEE Software},
	Keywords = {Internet of Things;software engineering;Internet of Things;IoT systems;IoT-oriented software engineering;key abstractions;Internet of things;Research and development;Software development;Software engineering;Internet of Things;IoT;software development;software engineering},
	Month = jan,
	Number = 1,
	Pages = {38--45},
	Title = {Key Abstractions for {IoT}-Oriented Software Engineering},
	Volume = 34,
	Year = 2017,
	Bdsk-Url-1 = {https://doi.org/10.1109/MS.2017.3}}

@phdthesis{calegari-phdthesis2018,
	Address = {Bologna, Italy},
	Author = {Calegari, Roberta},
	Date-Added = {2018-07-02 16:01:08 +0000},
	Date-Modified = {2018-07-02 16:24:32 +0000},
	School = {{\sc Alma Mater Studiorum}---Universit{\`a} di Bologna},
	Title = {Micro-Intelligence for the {IoT}: Logic-based Models and Technologies},
	Year = 2018,
	Bdsk-Url-1 = {http://www.ics.uci.edu/~fielding/pubs/dissertation/top.htm}}

@incollection{soda-aoseI,
	Author = {Omicini, Andrea},
	Booktitle = {Agent-Oriented Software Engineering},
	Date-Added = {2018-06-29 18:54:06 +0000},
	Date-Modified = {2018-07-02 16:24:59 +0000},
	Doi = {10.1007/3-540-44564-1\_12},
	Editor = {Ciancarini, Paolo and Wooldridge, Michael J.},
	Isbn = {978-3-540-41594-7},
	Isbn-10 = {3-540-41594-7},
	Isbn-Online = {978-3-540-44564-7},
	Issn = {0302-9743},
	Note = {1st International Workshop (AOSE 2000), Limerick, Ireland, 10~} # jun # {~2000. Revised Papers},
	Pages = {185--193},
	Publisher = {Springer-Verlag},
	Scopusid = {2-s2.0-70350650941},
	Series = {Lecture Notes in Computer Science},
	Title = {{{\sf SODA}}: Societies and Infrastructures in the Analysis and Design of Agent-based Systems},
	Url = {http://link.springer.com/10.1007/3-540-44564-1\_12},
	Volume = 1957,
	Year = 2001,
	Bdsk-Url-1 = {http://link.springer.com/10.1007/3-540-44564-1_12},
	Bdsk-Url-2 = {https://doi.org/10.1007/3-540-44564-1_12},
	Bdsk-Url-3 = {http://link.springer.com/10.1007/3-540-44564-1%5C_12},
	Bdsk-Url-4 = {https://doi.org/10.1007/3-540-44564-1%5C_12}}

@article{Jamont:2016:MCD,
	Acmid = {2995388},
	Address = {Inderscience Publishers, Geneva, SWITZERLAND},
	Author = {Jamont, Jean-Paul and Occello, Michel},
	Date-Added = {2018-06-08 09:31:48 +0000},
	Date-Modified = {2018-06-08 09:31:57 +0000},
	Doi = {10.1504/IJAOSE.2015.078435},
	Issn = {1746-1375},
	Issue_Date = {January 2016},
	Journal = {Int. J. Agent-Oriented Softw. Eng.},
	Keywords = {MAS, agent design, agent oriented analysis, agent-based systems, collective CPS, collective intelligence, cyber-physical systems, decentralised systems, embedded systems, multi-agent systems, real world applications},
	Month = jan,
	Number = {1},
	Numpages = {47},
	Pages = {22--68},
	Publisher = {Inderscience Publishers},
	Title = {Meeting the Challenges of Decentralised Embedded Applications Using Multi-agent Systems},
	Url = {http://dx.doi.org/10.1504/IJAOSE.2015.078435},
	Volume = {5},
	Year = {2016},
	Bdsk-Url-1 = {http://dx.doi.org/10.1504/IJAOSE.2015.078435}}

@article{van2008multi,
	Author = {Van der Hoek, Wiebe and Wooldridge, Michael},
	Date-Added = {2018-06-08 09:29:12 +0000},
	Date-Modified = {2018-06-08 09:29:12 +0000},
	Journal = {Foundations of Artificial Intelligence},
	Pages = {887--928},
	Publisher = {Elsevier},
	Title = {Multi-agent systems},
	Volume = {3},
	Year = {2008}}

@article{labelledlp-fi161,
	Author = {Calegari, Roberta and Denti, Enrico and Dovier, Agostino and Omicini, Andrea},
	Date-Added = {2018-06-08 09:16:21 +0000},
	Date-Modified = {2018-06-08 09:16:21 +0000},
	Doi = {10.3233/FI-2018-1695},
	Editor = {Fiorentini, Camillo and Momigliano, Alberto},
	Journal = {Fundamenta Informaticae},
	Keywords = {logic programming, labelled systems, labelled variables, formal semantics, meta-interpretation, situated intelligence},
	Note = {Special Issue CILC 2016},
	Numpages = 22,
	Pages = {53---74},
	Title = {Extending Logic Programming with Labelled Variables: Model and Semantics},
	Volume = 161,
	Year = 2018,
	Bdsk-Url-1 = {https://doi.org/10.3233/FI-2018-1695}}

@inproceedings{lvlp-cilc2016,
	Address = {Milano, Italy},
	Author = {Calegari, Roberta and Denti, Enrico and Dovier, Agostino and Omicini, Andrea},
	Booktitle = {CILC 2016 -- Italian Conference on Computational Logic. Proceedings of the 31st Italian Conference on Computational Logic},
	Date-Added = {2018-06-08 09:16:00 +0000},
	Date-Modified = {2018-06-08 09:16:00 +0000},
	Editor = {Fiorentini, Camillo and Momigliano, Alberto},
	Keywords = {labelled logic programming; labelled systems; formal semantics},
	Month = {20-22~} # jun,
	Note = {Proceedings of the 31st Italian Conference on Computational Logic},
	Pages = {5--20},
	Publisher = {CEUR-WS},
	Scopusid = {2-s2.0-84985916728},
	Series = {CEUR Workshop Proceedings},
	Subseries = {AI*IA Series},
	Title = {Labelled Variables in Logic Programming: Foundations},
	Url = {http://ceur-ws.org/Vol-1645/paper_7.pdf},
	Volume = 1645,
	Year = 2016,
	Bdsk-Url-1 = {http://ceur-ws.org/Vol-1645/paper_7.pdf}}

@incollection{attributedvars-plilpIV,
	_Note = {4th International Symposium (PLILP'92) Leuven, Belgium, August 26--28, 1992 Proceedings},
	_Url = {http://link.springer.com/10.1007/3-540-55844-6\_141},
	Author = {Holzbaur, Christian},
	Booktitle = {Programming Language Implementation and Logic Programming},
	Date-Added = {2018-06-08 09:13:34 +0000},
	Date-Modified = {2018-06-08 09:13:34 +0000},
	Doi = {10.1007/3-540-55844-6\_141},
	Editor = {Bruynooghe, Maurice and Wirsing, Martin},
	Issn = {0302-9743},
	Pages = {260--268},
	Publisher = {Springer},
	Series = {Lecture Notes in Computer Science},
	Title = {Metastructures vs.\ attributed variables in the context of extensible unification},
	Volume = 631,
	Year = 1992,
	Bdsk-Url-1 = {http://link.springer.com/10.1007/3-540-55844-6_141},
	Bdsk-Url-2 = {http://dx.doi.org/10.1007/3-540-55844-6_141},
	Bdsk-Url-3 = {http://dx.doi.org/10.1007/3-540-55844-6%5C_141},
	Bdsk-Url-4 = {https://dx.doi.org/10.1007/3-540-55844-6%5C_141}}

@book{gabbay-ldsbook1996,
	Author = {Gabbay, Dov M.},
	Date-Added = {2018-06-08 09:13:22 +0000},
	Date-Modified = {2018-06-08 09:13:22 +0000},
	Issn = {978-0-19-853833-2},
	Month = sep,
	Numpages = {510},
	Publisher = {Clarendon Press},
	Series = {Oxford Logic Guides},
	Title = {Labelled Deductive Systems, Volume 1},
	Url = {http://global.oup.com/academic/product/labelled-deductive-systems-9780198538332},
	Volume = 33,
	Year = 1996,
	Bdsk-Url-1 = {http://dx.doi.org/10.1023/A:1008254911778},
	Bdsk-Url-2 = {http://global.oup.com/academic/product/labelled-deductive-systems-9780198538332}}

@book{crevier1993ai,
	Author = {Crevier, Daniel},
	Date-Added = {2018-06-08 08:48:42 +0000},
	Date-Modified = {2018-06-08 08:48:42 +0000},
	Publisher = {Basic Books},
	Title = {AI: The tumultuous history of the search for artificial intelligence},
	Year = {1993}}

@book{microservices-saasbook,
	Address = {Berkely, CA, USA},
	Author = {Familiar, Bob},
	Booktitle = {Microservices, {IoT}, and {A}zure: Leveraging {DevOps} and Microservice Architecture to Deliver {SaaS} Solutions},
	Date-Added = {2018-06-08 08:48:30 +0000},
	Date-Modified = {2018-06-08 08:48:30 +0000},
	Edition = {1st},
	Isbn = {1484212762, 9781484212769},
	Publisher = {Apress},
	Title = {Microservices, {IoT}, and {A}zure: Leveraging {DevOps} and Microservice Architecture to Deliver {SaaS} Solutions},
	Year = 2015,
	Bdsk-Url-1 = {http://gen.lib.rus.ec/book/index.php?md5=3B504E6928D4D595DBC271EAA21355D1}}

@article{saas-cacm53,
	Acmid = {1721667},
	Address = {New York, NY, USA},
	Author = {Cusumano, Michael},
	Date-Added = {2018-06-08 08:47:57 +0000},
	Date-Modified = {2018-06-08 08:47:57 +0000},
	Doi = {10.1145/1721654.1721667},
	Issn = {0001-0782},
	Issue_Date = {April 2010},
	Journal = {Communications of the ACM},
	Month = apr,
	Number = 4,
	Numpages = {3},
	Pages = {27--29},
	Publisher = {ACM},
	Title = {Cloud Computing and {SaaS} as New Computing Platforms},
	Url = {http://dl.acm.org/citation.cfm?doid=1721667},
	Volume = 53,
	Year = 2010,
	Bdsk-Url-1 = {http://doi.acm.org/10.1145/1721654.1721667},
	Bdsk-Url-2 = {http://dx.doi.org/10.1145/1721654.1721667},
	Bdsk-Url-3 = {http://dl.acm.org/citation.cfm?doid=1721667},
	Bdsk-Url-4 = {https://dx.doi.org/10.1145/1721654.1721667}}

@inproceedings{lpaas-ic2e2018,
	Author = {Calegari, Roberta and Ciatto, Giovanni and Mariani, Stefano and Denti, Enrico and Omicini, Andrea},
	Booktitle = {2018 IEEE International Conference on Cloud Engineering (IC2E 208)},
	Date-Added = {2018-06-08 08:21:59 +0000},
	Date-Modified = {2018-06-08 08:21:59 +0000},
	Doi = {10.1109/IC2E.2018.00061},
	Isbn = {978-1-5386-5008-0},
	Month = {17--20~} # apr,
	Pages = {292--297},
	Publisher = {IEEE Computer Society},
	Title = {Micro-intelligence for the IoT: SE Challenges and Practice in LPaaS},
	Year = 2018,
	Bdsk-Url-1 = {https://doi.org/10.1109/IC2E.2018.00061}}

@inproceedings{lpaas-icnsc2017,
	Author = {Calegari, Roberta and Denti, Enrico and Mariani, Stefano and Omicini, Andrea},
	Booktitle = {2017 IEEE 14th International Conference on Networking, Sensing and Control (ICNSC 2017)},
	Date-Added = {2018-06-08 08:20:47 +0000},
	Date-Modified = {2018-06-08 08:20:47 +0000},
	Doi = {10.1109/ICNSC.2017.8000070},
	Editor = {Fortino, Giancarlo and Zhou, MengChu and Lukszo, Zofia and Vasilakos, Athanasios V. and Basile, Francesco and Palau, Carlos and Liotta, Antonio and Fanti, Maria Pia and Guerrieri, Antonio and Vinci, Andrea},
	Ieeeno = {8000070},
	Isbn = {978-1-5090-4428-3},
	Isbn-Online = {978-1-5090-4428-0},
	Keywords = {IoT, logic programming, LPaaS, pervasive computing, artificial intelligence, interoperability},
	Location = {Calabria, Italy},
	Month = may,
	Numpages = 6,
	Pages = {72--77},
	Publisher = {IEEE},
	Scopusid = {2-s2.0-85025141526},
	Title = {{L}ogic {P}rogramming as a {S}ervice ({LPaaS}): Intelligence for the {IoT}},
	Url = {http://ieeexplore.ieee.org/document/8000070/},
	Url-Pdf = {http://ieeexplore.ieee.org/stamp/stamp.jsp?arnumber=8000070},
	Year = 2017,
	Bdsk-Url-1 = {http://ieeexplore.ieee.org/document/8000070/},
	Bdsk-Url-2 = {https://doi.org/10.1109/ICNSC.2017.8000070}}

@inproceedings{lpaas-woa2016,
	Author = {Calegari, Roberta and Denti, Enrico and Mariani, Stefano and Omicini, Andrea},
	Booktitle = {WOA 2016 -- 17th Workshop ``From Objects to Agents''},
	Date-Added = {2018-06-08 08:20:07 +0000},
	Date-Modified = {2018-06-08 08:20:07 +0000},
	Editor = {Santoro, Corrado and Messina, Fabrizio and De Benedetti, Massimiliano},
	Issn = {1613-0073},
	Keywords = {Logic programming; Pervasive systems; IoT; LP-as-a-service},
	Location = {Catania, Italy},
	Month = {29--30~} # jul,
	Note = {Proceedings of the 17th Workshop ``From Objects to Agents'' co-located with 18th European Agent Systems Summer School (EASSS 2016)},
	Pages = {91--99},
	Publisher = {Sun SITE Central Europe, RWTH Aachen University},
	Scopusid = {2-s2.0-84985995176},
	Series = {CEUR Workshop Proceedings},
	Subseries = {AI*IA Series},
	Title = {Towards Logic Programming as a Service: Experiments in {\sf tu}{P}rolog},
	Url = {http://ceur-ws.org/Vol-1664/w14.pdf},
	Volume = 1664,
	Year = 2016,
	Bdsk-Url-1 = {http://ceur-ws.org/Vol-1664/w14.pdf}}

@article{lpaas-ijguc2018,
	Author = {Calegari, Roberta and Denti, Enrico and Mariani, Stefano and Omicini, Andrea},
	Date-Added = {2018-06-07 13:03:57 +0000},
	Date-Modified = {2018-06-07 13:04:28 +0000},
	Editor = {de Macedo, Douglas Dyllon Jeronimo and Messina, Fabrizio},
	Issn = {1741-847X},
	Issn-Online = {1741-8488},
	Journal = {International Journal of Grid and Utility Computing},
	Keywords = {IoT, logic programming, multi-agent systems, pervasive computing, LPaaS, artificial intelligence, interoperability},
	Publisher = {Inderscience},
	Title = {Logic Programming as a Service in Multi-Agent Systems for the {I}nternet of {T}hings},
	Year = {2018}}

@article{agensfaber-entcs150,
	_Note = {1st International Workshop ``Coordination and Organization'' (CoOrg 2005), COORDINATION 2005, Namur, Belgium, 22~} # apr # {~2005. Proceedings},
	_Url = {http://dx.doi.org/10.1016/j.entcs.2006.03.003},
	Author = {Omicini, Andrea and Ricci, Alessandro and Viroli, Mirko},
	Date-Added = {2018-06-07 12:58:39 +0000},
	Date-Modified = {2018-06-07 12:58:39 +0000},
	Doi = {10.1016/j.entcs.2006.03.003},
	Editor = {Boella, Guido and van der Torre, Leendert},
	Issn = {1571-0661},
	Journal = {Electronic Notes in Theoretical Computer Science},
	Month = {29~} # may,
	Number = 3,
	Pages = {21--36},
	Publisher = {Elsevier Science B.V.},
	Title = {{\sl {A}gens {F}aber}: Toward A Theory of Artefacts for {MAS}},
	Volume = 150,
	Year = 2006,
	Bdsk-Url-1 = {http://dx.doi.org/10.1016/j.entcs.2006.03.003}}

@incollection{incrementalreasoning-ccis190,
	Address = {Berlin, Heidelberg},
	Author = {Oliya, Mohammad and Pung, Hung Keng},
	Booktitle = {Advances in Computing and Communications: First International Conference, ACC 2011, Kochi, India, July 22-24, 2011. Proceedings, Part I},
	Date-Added = {2018-06-04 12:13:20 +0000},
	Date-Modified = {2018-06-04 12:14:06 +0000},
	Doi = {10.1007/978-3-642-22709-7\_24},
	Editor = {Abraham, Ajith and Lloret Mauri, Jaime and Buford, John F. and Suzuki, Junichi and Thampi, Sabu M.},
	Isbn = {978-3-642-22709-7},
	Pages = {232--241},
	Publisher = {Springer},
	Series = {Communications in Computer and Information Science},
	Title = {Towards Incremental Reasoning for Context Aware Systems},
	Url = {http://link.springer.com/10.1007/978-3-642-22709-7_24},
	Volume = 190,
	Year = 2011,
	Bdsk-Url-1 = {http://dx.doi.org/10.1007/978-3-642-22709-7_24},
	Bdsk-Url-2 = {http://link.springer.com/10.1007/978-3-642-22709-7_24},
	Bdsk-Url-3 = {https://dx.doi.org/10.1007/978-3-642-22709-7_24},
	Bdsk-Url-4 = {http://dx.doi.org/10.1007/978-3-642-22709-7%5C_24}}

@article{situatedlp-ker19,
	Abstract = {Context-aware pervasive systems are emerging as an important class of applications. Such systems can respond intelligently to contextual information about the physical world acquired via sensors and information about the computational environment. A declarative approach to building context-aware pervasive systems is presented, and the notion of the situation program is introduced, which highlights the primacy of the situation abstraction for building context-aware pervasive systems. There is also a demonstration of how to manipulate situation programs using meta-programming within an extension of the Prolog logic programming language which is called LogicCAP. Such meta-reasoning enables complex situations to be described in terms of other situations. Furthermore, a discussion is given on how the design of situation programs can affect the properties of a context-aware system. The approach encourages a high-level of abstraction for representing and reasoning with situations, and support},
	Address = {Cambridge, UK},
	Author = {Loke, Seng W.},
	Date-Added = {2018-06-04 12:12:47 +0000},
	Date-Modified = {2018-06-04 12:12:47 +0000},
	Doi = {10.1017/S0269888905000263},
	Journal = {The Knowledge Engineering Review},
	Month = sep,
	Number = 3,
	Pages = {213--233},
	Publisher = {Cambridge University Press},
	Title = {Representing and reasoning with situations for context-aware pervasive computing: a logic programming perspective},
	Url = {http://www.cambridge.org/core/article/div-class-title-representing-and-reasoning-with-situations-for-context-aware-pervasive-computing-a-logic-programming-perspective-div/D206E5D8C08D587361E11BF3093ADF04},
	Volume = 19,
	Year = 2004,
	Bdsk-Url-1 = {https://www.cambridge.org/core/article/div-class-title-representing-and-reasoning-with-situations-for-context-aware-pervasive-computing-a-logic-programming-perspective-div/D206E5D8C08D587361E11BF3093ADF04},
	Bdsk-Url-2 = {http://dx.doi.org/10.1017/S0269888905000263},
	Bdsk-Url-3 = {http://www.cambridge.org/core/article/div-class-title-representing-and-reasoning-with-situations-for-context-aware-pervasive-computing-a-logic-programming-perspective-div/D206E5D8C08D587361E11BF3093ADF04},
	Bdsk-Url-4 = {https://dx.doi.org/10.1017/S0269888905000263}}

@book{brownlee2011,
	Author = {Brownlee, Jason},
	Date-Added = {2018-06-04 12:12:30 +0000},
	Date-Modified = {2018-06-04 12:12:30 +0000},
	Publisher = {Jason Brownlee},
	Title = {Clever algorithms: nature-inspired programming recipes},
	Year = {2011}}

@article{aosmartobjiot-ieeetsmcPP,
	Author = {Fortino, Giancarlo and Russo, Wilma and Savaglio, Claudio and Shen, Weiming and Zhou, Mengchu},
	Date-Added = {2018-06-01 08:04:53 +0000},
	Date-Modified = {2018-06-01 08:04:53 +0000},
	Doi = {10.1109/TSMC.2017.2780618},
	Issn = {2168-2216},
	Journal = {IEEE Transactions on Systems, Man, and Cybernetics: Systems},
	Keywords = {Computational modeling;Cybernetics;Internet of Things;Middleware;Programming;System analysis and design;Wireless sensor networks;Agent-oriented software engineering;Internet of Things (IoT);cooperative smart objects;multiagent systems (MASs)},
	Month = dec,
	Number = 99,
	Pages = {1--18},
	Title = {Agent-Oriented Cooperative Smart Objects: From {IoT} System Design to Implementation},
	Url = {http://ieeexplore.ieee.org/document/8241454/},
	Volume = {PP},
	Year = 2017,
	Bdsk-Url-1 = {https://dx.doi.org/10.1109/TSMC.2017.2780618},
	Bdsk-Url-2 = {http://ieeexplore.ieee.org/document/8241454/}}

@inproceedings{Khan2012,
	Author = {Khan, R. and Khan, S. U. and Zaheer, R. and Khan, S.},
	Booktitle = {2012 10th International Conference on Frontiers of Information Technology},
	Date-Added = {2018-06-01 07:38:10 +0000},
	Date-Modified = {2018-06-01 07:39:05 +0000},
	Doi = {10.1109/FIT.2012.53},
	Keywords = {Internet of Things;learning (artificial intelligence);Internet of Things architecture;generic architecture;machine-to-machine learning;Computer architecture;Intelligent sensors;Internet;Monitoring;Security;Sensor systems;Internet of Things;IoT applications;IoT architecture;IoT security;RFID;ubiquitous computing},
	Month = {Dec},
	Pages = {257-260},
	Title = {Future Internet: The Internet of Things Architecture, Possible Applications and Key Challenges},
	Year = {2012},
	Bdsk-Url-1 = {https://doi.org/10.1109/FIT.2012.53}}

@inproceedings{Tan2010,
	Author = {Tan, Lu and Wang, Neng},
	Booktitle = {2010 3rd International Conference on Advanced Computer Theory and Engineering(ICACTE)},
	Date-Added = {2018-06-01 07:37:00 +0000},
	Date-Modified = {2018-06-01 07:37:08 +0000},
	Doi = {10.1109/ICACTE.2010.5579543},
	Issn = {2154-7491},
	Keywords = {Internet;open systems;radiofrequency identification;software architecture;ubiquitous computing;Internet of things;RFID;communication era;radio frequency identification techniques;ubiquitous computing;Artificial intelligence;Computer architecture;Educational institutions;Geology;IEEE 802.11 Standards;Logic gates;Internet of Things;M2M;RFID;automatic facilities management;smart campus;ubiqutious computing},
	Month = {Aug},
	Pages = {V5-376-V5-380},
	Title = {Future internet: The Internet of Things},
	Volume = {5},
	Year = {2010},
	Bdsk-Url-1 = {https://doi.org/10.1109/ICACTE.2010.5579543}}

@inproceedings{Chenhui2012,
	Author = {Xiang, Chenhui and Li, Xinran},
	Booktitle = {2012 IEEE International Conference on Computer Science and Automation Engineering},
	Date-Added = {2018-06-01 07:16:23 +0000},
	Date-Modified = {2018-06-01 07:16:37 +0000},
	Doi = {10.1109/ICSESS.2012.6269471},
	Issn = {2327-0586},
	Keywords = {cloud computing;radiofrequency identification;Internet of Things;cloud computing technology;information industry;network communication technology;radio frequency identification technology;sensor technology;Antennas;Monitoring;Radiofrequency identification;Reliability;Robot sensing systems;Wireless sensor networks;application;architecture;key technologies;the Internet of Things},
	Month = {June},
	Pages = {325-328},
	Title = {General analysis on architecture and key technologies about Internet of Things},
	Year = {2012},
	Bdsk-Url-1 = {https://doi.org/10.1109/ICSESS.2012.6269471}}

@inproceedings{Savaglio2016,
	Author = {Savaglio, C. and Fortino, G. and Zhou, M.},
	Booktitle = {2016 IEEE 3rd World Forum on Internet of Things (WF-IoT)},
	Date-Added = {2018-06-01 07:04:26 +0000},
	Date-Modified = {2018-06-01 07:04:36 +0000},
	Doi = {10.1109/WF-IoT.2016.7845459},
	Keywords = {Internet of Things;fault tolerant computing;middleware;multi-agent systems;open systems;ACOSO middleware;Internet of Things;MAS;Omnet++ simulator;agent abstraction;agent-based cooperating SO middleware;distributed-self-steering heterogeneous IoT systems;interoperable-cognitive autonomic IoT systems;multiagent systems;performance verification;smart objects;Agent-based computing;Autonomic Computing;Cognitive Systems;Internet of Things;Interoperability},
	Month = {Dec},
	Pages = {58-63},
	Title = {Towards interoperable, cognitive and autonomic IoT systems: An agent-based approach},
	Year = {2016},
	Bdsk-Url-1 = {https://doi.org/10.1109/WF-IoT.2016.7845459}}

@inproceedings{Fortino2014,
	Author = {Fortino, G. and Guerrieri, A. and Russo, W. and Savaglio, C.},
	Booktitle = {Proceedings of the 2014 IEEE 18th International Conference on Computer Supported Cooperative Work in Design (CSCWD)},
	Date-Added = {2018-06-01 07:03:01 +0000},
	Date-Modified = {2018-06-01 07:03:08 +0000},
	Doi = {10.1109/CSCWD.2014.6846894},
	Keywords = {Internet of Things;cloud computing;middleware;multi-agent systems;object-oriented methods;open systems;software architecture;ACOSO;BodyCloud;Internet of Things;agent-based computing;agent-oriented IoT architecture;agent-oriented middleware;application domains;autonomous IoT components;cloud computing;cloud-assisted IoT architecture;complementary mainstream paradigms;cooperating IoT systems;cyber-physical smart pervasive systems;decentralized IoT systems;distributed IoT components;dynamic IoT systems;health-care;heterogeneous IoT components;high performance computing capabilities;large-scale distributed computing:;large-scale sensor-based systems;logistics;multiagent systems;open IoT systems;sensor-cloud infrastructure;smart cities;smart grid;smart object-oriented IoT;storage resources;transportation;Cloud computing;Computational modeling;Computer architecture;Intelligent sensors;Protocols;Agent-oriented Computing;Cloud Computing;Cooperating Smart Objects;Internet of Things;Middleware},
	Month = {May},
	Pages = {493-498},
	Title = {Integration of agent-based and Cloud Computing for the smart objects-oriented IoT},
	Year = {2014},
	Bdsk-Url-1 = {https://doi.org/10.1109/CSCWD.2014.6846894}}

@article{Larrucea2017,
	Author = {Larrucea, X. and Combelles, A. and Favaro, J. and Taneja, K.},
	Date-Added = {2018-05-31 12:57:44 +0000},
	Date-Modified = {2018-05-31 12:57:44 +0000},
	Doi = {10.1109/MS.2017.28},
	Issn = {0740-7459},
	Journal = {IEEE Software},
	Keywords = {Best practices;Cyber-physical systems;Internet of things;Scalability;Software development;Software engineering;Special issues and sections;Internet of Things;IoT;cyber-physical systems;model-based software engineering;scalability;software development;software engineering},
	Month = {Jan},
	Number = {1},
	Pages = {24-28},
	Title = {Software Engineering for the Internet of Things},
	Url = {http://ieeexplore.ieee.org/document/7819384/},
	Volume = {34},
	Year = {2017},
	Bdsk-Url-1 = {https://dx.doi.org/10.1109/MS.2017.28},
	Bdsk-Url-2 = {http://ieeexplore.ieee.org/document/7819384/}}

@inproceedings{agentobj-cscwd2012,
	Author = {Fortino, G. and Guerrieri, A. and Russo, W.},
	Booktitle = {2012 IEEE 16th International Conference on Computer Supported Cooperative Work in Design (CSCWD 2012)},
	Date-Added = {2018-05-31 11:35:15 +0000},
	Date-Modified = {2018-06-29 16:15:08 +0000},
	Doi = {10.1109/CSCWD.2012.6221929},
	Isbn = {978-1-4673-1211-0},
	Isbn-Online = {978-1-4673-1212-7},
	Keywords = {Internet;object-oriented programming;software agents;ubiquitous computing;Internet of Things;IoT infrastructure;agent paradigm;agent-oriented smart object development;context-aware smart objects;decentralized system;heterogeneous computing system;multilayered agent-based architecture;multiple agent languages;physical/digital objects;system architecture;Bluetooth;IP networks;Pervasive computing;Plugs;Protocols;Sensors;Zigbee;Agent Technology;Internet of Things;Middleware;Smart Objects;Wireless Sensor and Actuator Networks},
	Month = may,
	Pages = {907--912},
	Publisher = {IEEE},
	Title = {Agent-oriented smart objects development},
	Url = {http://ieeexplore.ieee.org/document/6221929/},
	Year = 2012,
	Bdsk-Url-1 = {https://doi.org/10.1109/CSCWD.2012.6221929},
	Bdsk-Url-2 = {http://ieeexplore.ieee.org/document/6221929/}}

@article{agentambint-ieeeis30,
	Author = {Spanoudakis, Nikolaos and Moraitis, Pavlos},
	Date-Added = {2018-05-31 11:31:28 +0000},
	Date-Modified = {2018-06-29 16:01:38 +0000},
	Doi = {10.1109/MIS.2015.3},
	Issn = {1541-1672},
	Journal = {IEEE Intelligent Systems},
	Keywords = {ambient intelligence;assisted living;object-oriented programming;software agents;software engineering;ASEME;AmI system;agent systems engineering methodology;agent-oriented software engineering;ambient assisted living;ambient intelligence system;Ambient intelligence;Analytical models;Intelligent systems;Multi-agent systems;Unified modeling language;ambient assisted living;ambient intelligence;healthcare;intelligent agents;intelligent systems;methodologies;multiagent systems;software architectures},
	Month = may,
	Number = 3,
	Pages = {60--67},
	Title = {Engineering ambient intelligence systems using agent technology},
	Url = {http://ieeexplore.ieee.org/document/7006373/},
	Volume = 30,
	Year = 2015,
	Bdsk-Url-1 = {https://doi.org/10.1109/MIS.2015.3},
	Bdsk-Url-2 = {http://ieeexplore.ieee.org/document/7006373/}}

@inproceedings{agentiot-compsacw2015,
	Author = {Kato, Takumi and Chiba, Ryo and Takahashi, Hideyuki and Kinoshita, Tetsuo},
	Booktitle = {2015 IEEE 39th Annual Computer Software and Applications Conference (COMPSACW 2015)},
	Date-Added = {2018-05-31 11:27:38 +0000},
	Date-Modified = {2018-06-29 15:56:28 +0000},
	Doi = {10.1109/COMPSAC.2015.237},
	Keywords = {Internet of Things;multi-agent systems;Internet of Things applications;IoT agents;IoT applications;IoT devices;advanced logistics;agent-based device management function;agent-oriented cooperation infrastructure;cooperation function;self-state management function;smart devices;Actuators;Intelligent sensors;Logistics;Mobile robots;Robot sensing systems;Cooperation;Internet of Things;Multiagent;Networked Robots},
	Month = jul,
	Pages = {223--227},
	Title = {Agent-Oriented Cooperation of IoT Devices Towards Advanced Logistics},
	Url = {http://ieeexplore.ieee.org/document/7273358/},
	Volume = 3,
	Year = 2015,
	Bdsk-Url-1 = {https://doi.org/10.1109/COMPSAC.2015.237},
	Bdsk-Url-2 = {http://ieeexplore.ieee.org/document/7273358/}}

@inproceedings{cascadas-dis2006,
	Author = {Manzalini, Antonio and Zambonelli, Franco},
	Booktitle = {IEEE Workshop on Distributed Intelligent Systems: Collective Intelligence and Its Applications (DIS'06)},
	Date-Added = {2018-05-31 11:26:34 +0000},
	Date-Modified = {2018-06-29 15:57:37 +0000},
	Doi = {10.1109/DIS.2006.71},
	Keywords = {telecommunication computing;ubiquitous computing;CASCADAS vision;adaptive communication service;autonomic communication element;autonomic communication service;innovative communication service;service provisioning call;situation-aware communication service;ubiquitous communication service;Context;Context-aware services;Costs;Environmental factors;Humans;Information security;Intelligent networks;Intelligent systems;Telecommunications;Web and internet services},
	Month = jun,
	Pages = {383-388},
	Title = {Towards Autonomic and Situation-Aware Communication Services: the {CASCADAS} Vision},
	Year = {2006},
	Bdsk-Url-1 = {https://doi.org/10.1109/DIS.2006.71}}

@incollection{agentiot-sci737,
	_Url = {http://link.springer.com/10.1007/978-3-319-66379-1_27},
	Author = {Savaglio, Claudio and Fortino, Giancarlo and Ganzha, Maria and Paprzycki, Marcin and Badica, Costin and Ivanovic, Mirjana},
	Booktitle = {Intelligent Distributed Computing XI},
	Date-Modified = {2018-07-02 16:40:21 +0000},
	Doi = {10.1007/978-3-319-66379-1\_27},
	Editor = {Ivanovi{\'c}, Mirjana and B{\u a}dic{\u a}, Costin and Dix, J{\"u}rgen and Jovanovi{\'c}, Zoran and Malgeri, Michele and Savi{\'c}, Milo{\v s}},
	Isbn = {978-3-319-66378-4},
	Pages = {307-320},
	Publisher = {Springer},
	Series = {Studies in Computational Intelligence},
	Title = {Agent-Based Computing in the Internet of Things: A Survey},
	Volume = 737,
	Year = 2018,
	Bdsk-Url-1 = {http://link.springer.com/10.1007/978-3-319-66379-1_27},
	Bdsk-Url-2 = {https://doi.org/10.1007/978-3-319-66379-1_27},
	Bdsk-Url-3 = {https://doi.org/10.1007/978-3-319-66379-1%5C_27}}
